#include "gdt.h"
void _start(void)
{
	main();
}

void int_newint();
void int_smileyscreen();

char *vidmem = (char *) 0xb8000;

desc_table(IDT, 256) { };

struct {
   unsigned short limit __attribute__ ((packed));
   union DT_entry *idt __attribute__ ((packed));
   } loadidt = { (256 * sizeof(union DT_entry) - 1), IDT};

void set_vector(void *handler, unsigned char interrupt, unsigned short control_major) {
   unsigned short codesegment = 0x08;
   asm volatile("movw %%cs,%0":"=g" (codesegment));

   IDT[interrupt].gate.offset_low = (unsigned short) (((unsigned long)handler)&0xffff);
   IDT[interrupt].gate.selector = codesegment;
   IDT[interrupt].gate.access = control_major;
   IDT[interrupt].gate.offset_high = (unsigned short) (((unsigned long)handler) >> 16);
   }

void int_null();
asm (
   ".globl int_null	\n"
   "int_null:		\n"
   "   iret		\n"  /* Exit Interrupt */
   );

void InitIDT() {
   int cnt;
   for(cnt=0;cnt<32;cnt++) {
      set_vector(int_null, cnt, D_PRESENT + D_INT + D_DPL1);
      }
   for(;cnt<256;cnt++) {
      set_vector(int_null, cnt, D_PRESENT + D_INT + D_DPL3);
      }

   set_vector(int_newint, 33, D_PRESENT + D_INT + D_DPL3);
//   set_vector(int_smileyscreen, 34, D_PRESENT + D_INT + D_DPL3);

   asm (
      "lidt (%0)			\n"  /* Load the IDT */
      "pushfl				\n"  /* Clear the NT flag */
      "andl $0xffffbfff, (%%esp)	\n"
      "popfl				\n"
      :
      : "r" ((char *) &loadidt)
      );
   asm("sti");
   }

void int_newint(void)
{
	long int newintaddr;
	int newintnum;
	asm("
		movl %%eax,%0
		mov %%bx,%1"
		: "=g" (newintaddr), "=g" (newintnum));
	set_vector((int *)newintaddr,newintnum, D_PRESENT + D_INT + D_DPL3);
}

void int_smileyscreen() {
   int cnt;
   for(cnt=0;cnt<80*25;cnt++) {
      vidmem[cnt*2] = 0x02;
      vidmem[cnt*2+1] = 0x07;
      }
   }

int main() {
   int cnt;
   InitIDT();
   for(cnt=0;cnt<80*25;cnt++) {
      vidmem[cnt*2] = 0x01;
      vidmem[cnt*2+1] = 0x07;
      }
   asm("
      movl %0,%%eax
      mov $34,%%bx"
      : :  "g" (&int_smileyscreen) );
   asm("int $33");
   asm("jmp 0x20000");
   while(1) { }
   }
